
        include "processor.inc"
        
        
.division_data  udata
AARGB1  res     1
AARGB0  res     1               ; msb
BARGB1  res     1
BARGB0  res     1               ; msb
REMB1   res     1
REMB0   res     1               ; msb
        
.division_code  code


LSB     equ     0
                
UDIV1515        macro
;
;       Max Timing:     5+8+14*12+6 = 187 clks
;
;       Min Timing:     5+8+14*11+6 = 173 clks
;
;       PM: 5+8+14*14+6 = 215           DM: 6
;
                variable i

                MOVFF           BARGB1,WREG
                SUBWF           REMB1, F
                MOVFF           BARGB0,WREG
                SUBWFB  	REMB0, F
                RLCF            AARGB0, F

                RLCF            AARGB0,W
                RLCF            REMB1, F
                RLCF            REMB0, F
                MOVFF           BARGB1,WREG
                ADDWF           REMB1, F
                MOVFF           BARGB0,WREG
                ADDWFC  	REMB0, F
                RLCF            AARGB0, F

                variable i = D'2'

                while i < D'8'

                RLCF            AARGB0,W
                RLCF            REMB1, F
                RLCF            REMB0, F
                MOVFF           BARGB1,WREG

                BTFSS           AARGB0,LSB
                GOTO            UADD55#v(i)

                SUBWF           REMB1, F
                MOVFF           BARGB0,WREG
                SUBWFB  	REMB0, F
                GOTO            UOK55#v(i)

UADD55#v(i)     ADDWF           REMB1, F
                MOVFF           BARGB0,WREG
                ADDWFC  	REMB0, F
        
UOK55#v(i)      RLCF            AARGB0, F

                variable i=i+1

                endw

                RLCF            AARGB1,W
                RLCF            REMB1, F
                RLCF            REMB0, F
                MOVFF           BARGB1,WREG

                BTFSS           AARGB0,LSB
                GOTO            UADD558

                SUBWF           REMB1, F
                MOVFF           BARGB0,WREG
                SUBWFB  	REMB0, F
                GOTO            UOK558

UADD558         ADDWF           REMB1, F
                MOVFF           BARGB0,WREG
                ADDWFC  	REMB0, F
        
UOK558          RLCF            AARGB1, F

                variable i = D'9'

                while i < D'16'

                RLCF            AARGB1,W
                RLCF            REMB1, F
                RLCF            REMB0, F
                MOVFF           BARGB1,WREG

                BTFSS           AARGB1,LSB
                GOTO            UADD55#v(i)

                SUBWF           REMB1, F
                MOVFF           BARGB0,WREG
                SUBWFB  	REMB0, F
                GOTO            UOK55#v(i)

UADD55#v(i)     ADDWF           REMB1, F
                MOVFF           BARGB0,WREG
                ADDWFC  	REMB0, F
        
UOK55#v(i)      RLCF            AARGB1, F


                variable i=i+1

                endw

                BTFSC           AARGB1,LSB
                GOTO            UOK55
                MOVFF           BARGB1,WREG
                ADDWF           REMB1, F
                MOVFF           BARGB0,WREG
                ADDWFC  	REMB0, F
UOK55

                endm

;**********************************************************************************************
;**********************************************************************************************
;
;       15/15 Bit Unsigned Fixed Point Divide 15/15 -> 15.15
;
;       Input:  15 bit unsigned fixed point dividend in AARGB0, AARGB1
;               15 bit unsigned fixed point divisor in BARGB0, BARGB1
;
;       Use:    CALL    FXD1515U
;
;       Output: 15 bit unsigned fixed point quotient in AARGB0, AARGB1
;               15 bit unsigned fixed point remainder in REMB0, REMB1
;
;       Result: AARG, REM  <--  AARG / BARG
;
;       Max Timing:     2+187+2 = 191 clks
;
;       Min Timing:     2+173+2 = 177 clks
;
;       PM: 2+215+1 = 218               DM: 6
;

        global  FXD1515U
FXD1515U:       
        CLRF            REMB0
        CLRF            REMB1

        ;; copy the arguments from FSR0 and FSR1
        movff   INDF0, AARGB1   ; start with the LSB
        movff   INDF1, BARGB1

        ;; now do the MSB
        movlw   1
        movff   PLUSW0, AARGB0
        movff   PLUSW1, BARGB0
        
        ;; now do the division
        UDIV1515

        ;; copy the results back to user memory
        movff   AARGB1, INDF0
        movlw   1
        movff   AARGB0, PLUSW0
        
        RETLW           0x00

        end