;;; -*- asm -*-
;;;
;;; Define processor specific information for the project.
;;; 
;;; Copyright (c) 2004  Robert James Kaes <rjk@wormbytes.ca>
;;;   All rights reserved.
;;;
;;;
;;; This program is free software; you can redistribute it and/or modify it
;;;  under the terms of the GNU General Public License as published by the
;;; Free Software Foundation; either version 2, or (at your option) any
;;; later version.
;;;
;;; This program is distributed in the hope that it will be useful, but
;;; WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;;  General Public License for more details.
;;; 


#ifndef PROCESSOR_H
#define PROCESSOR_H

	processor	p18f242
	include		"p18f242.inc"
	radix		dec

        include         "macro.inc"

	;; Define the processor in use as an 18' series PIC
#define __PIC18		1

	;; Indicate that the processor uses a 16bit core (rather than,
	;; say a 14 bit core like a 16f84.)
#define __COREBIT	16

	;; Define the processor speed (40 MHz)
#define OSC_FREQ	D'40000000'


#ifndef RX0DBEN
RX0DBEN         EQU  H'0002'    ;For backward compatibility
#endif


#endif
