;;;
;;; Copyright (c) 2004  Robert James Kaes <rjk@wormbytes.ca>
;;;   All rights reserved.
;;;
;;;
;;; This program is free software; you can redistribute it and/or modify it
;;;  under the terms of the GNU General Public License as published by the
;;; Free Software Foundation; either version 2, or (at your option) any
;;; later version.
;;;
;;; This program is distributed in the hope that it will be useful, but
;;; WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;;  General Public License for more details.
;;; 

        include "processor.inc"
        include "division.inc"

	;; Set up the various configuration information
        __CONFIG        _CONFIG1H, _OSCS_OFF_1H & _HSPLL_OSC_1H
        __CONFIG        _CONFIG2L, _BOR_OFF_2L & _PWRT_ON_2L
        __CONFIG        _CONFIG2H, _WDT_OFF_2H
        __CONFIG        300004h, 0xff
        __CONFIG        300005h, 0xff
        __CONFIG        _CONFIG4L, _DEBUG_OFF_4L & _LVP_OFF_4L
        __CONFIG        300007h, 0xff
        __CONFIG        _CONFIG5L, 0xff
        __CONFIG        _CONFIG5H, 0xff
        __CONFIG        _CONFIG6L, 0xff
        __CONFIG        _CONFIG6H, 0xff
        __CONFIG        _CONFIG7L, 0xff
        __CONFIG        _CONFIG7H, 0xff


;;; --------------------------------------------------------------------
;;;
;;; Reset Vector (startup)
;;;
.reset_vector	code	0h
	goto	main


.main_data      udata
dividend        res     2
divisor         res     2
temp            res     1

.main_code      code

main:
      	;; Initialize a few registers to make sure they're in a known
	;; good state.
	clrf	STATUS		; init the status register
	clrf	INTCON		; disable interrupts


        movlw   10
        movwf   temp

        movlw   9
        cpfsgt  temp
        nop

        ;; what's in W here

        ;; load 2400 into the dividend
        banksel dividend
        movlw   LOW(6000)
        movwf   dividend
        movlw   HIGH(6000)
        movwf   dividend + 1

        ;; now load 24 into the divisor
        banksel divisor
        movlw   LOW(60)
        movwf   divisor
        movlw   HIGH(60)
        movwf   divisor + 1

        ;; now do the division
        div1515u        dividend, divisor

        ;; all done, loop
loop:
        nop
        bra     loop

        end
        